//---------------------------------------------------------------------------
#ifndef CpkKeyWins1H
#define CpkKeyWins1H
//---------------------------------------------------------------------------
#include <vcl\Classes.hpp>
#include <vcl\Controls.hpp>
#include <vcl\StdCtrls.hpp>
#include <vcl\Forms.hpp>
#include <vcl\ComCtrls.hpp>
#include <vcl\ExtCtrls.hpp>
#include "explbtn.hpp"
#include <vcl\Menus.hpp>

#include "PGPbuffers.h"
//---------------------------------------------------------------------------
class TCpkKeyList1 : public TPGPkeylist
{
public:
   TStringList *shorts;
   virtual __fastcall TCpkKeyList1();
   virtual __fastcall TCpkKeyList1(AnsiString filename);
   virtual __fastcall TCpkKeyList1(TPGPbuffer *keys);
   virtual __fastcall TCpkKeyList1(TPGPkeylist *keys);
   virtual __fastcall~TCpkKeyList1();
   void __fastcall SaveToFileBak(AnsiString &docname, int bakcopies);
   virtual void __fastcall LoadFromFile(AnsiString filename);
   virtual int __fastcall AddKeys(TPGPbuffer *keys);
   virtual int __fastcall AddKeys(TPGPkeylist *keys);
   void __fastcall GetShortAndAddressLengths(int &shrtlen, int &addrlen);
};

class TCpkKeyWin1 : public TForm
{
__published:	// IDE-managed Components
	TTreeView *TreeView;
	TPanel *Panel1;
	TBevel *Bevel5;
	TBevel *Bevel3;
	TBevel *Bevel2;
	TBevel *Bevel1;
	TOfficeButton *DeleteBtn;
	TOfficeButton *HelpBtn;
	TOfficeButton *OkBtn;
	TOfficeButton *ImportBtn;
	TOfficeButton *SaveBtn;
	TOfficeButton *DocsBtn;
	TOfficeButton *RefreshBtn;
	TOfficeButton *DisableBtn;
	TOfficeButton *RequestBtn;
	TOfficeButton *ClearAllBtn;
	TPopupMenu *PopupMenu;
	TMenuItem *PopDisableItem;
	TMenuItem *N1;
	TMenuItem *Clear1;
	TMenuItem *PopSaveItem;
	TMenuItem *PopRefreshItem;
	TMenuItem *PopImportItem;
	TMenuItem *N3;
	TMenuItem *PopDeleteItem;
	TPopupMenu *PopupMenu2;
	TMenuItem *PubringItem;
	TMenuItem *ListDocItem;
	TPopupMenu *PopupMenu1;
	TMenuItem *RemailerAlldocsItem;
	TMenuItem *N2;
	TMenuItem *RemailerConfigItem;
	TMenuItem *RemailerKeyItem;
	TMenuItem *RemailerHelpItem;
	TMenuItem *RemailerStatsItem;
	TTimer *Timer1;
	TTimer *FlashTimer;
	TImageList *ImageList2;
	TMenuItem *PopExpandItem;
	TMenuItem *PopCollapseItem;
	TMenuItem *N4;
	void __fastcall FormClose(TObject *Sender, TCloseAction &Action);
	void __fastcall Timer1Timer(TObject *Sender);
	void __fastcall FormResize(TObject *Sender);
	void __fastcall ClearAllBtnClick(TObject *Sender);
	void __fastcall TreeViewMouseDown(TObject *Sender, TMouseButton Button,
	TShiftState Shift, int X, int Y);
	void __fastcall DisableBtnClick(TObject *Sender);
	void __fastcall TreeViewChange(TObject *Sender, TTreeNode *Node);
	void __fastcall OkBtnClick(TObject *Sender);
	void __fastcall FormCloseQuery(TObject *Sender, bool &CanClose);
	void __fastcall PopExpandItemClick(TObject *Sender);
	void __fastcall PopCollapseItemClick(TObject *Sender);
	void __fastcall SaveBtnClick(TObject *Sender);
	void __fastcall RefreshBtnClick(TObject *Sender);
	void __fastcall DeleteBtnClick(TObject *Sender);
	void __fastcall RemailerDocItemClick(TObject *Sender);
	void __fastcall HelpBtnClick(TObject *Sender);
	void __fastcall RemailerConfigItemClick(TObject *Sender);
private:	// User declarations
public:		// User declarations
    TList *keynodes;
    TCpkKeyList1 *keys;
    TStringList *newkeys;
    int sLen,aLen,curkey;
    bool modified,checksave;
	__fastcall TCpkKeyWin1(TComponent* Owner);
 	virtual __fastcall ~TCpkKeyWin1();
    TPGPbuffer* __fastcall GetKey(int atPos);
    void __fastcall SetTreeItemBold(TTreeNode *ANode, bool Value, TTreeView *ATree);
    void __fastcall MakeMessage(TStrings *message, AnsiString &addrs, AnsiString &subject);
    void __fastcall SetNothingSelected();
    void __fastcall SetHelpBtnPos();
    void __fastcall GenTreeView();
    void __fastcall SaveKeys();
    void __fastcall SetCount(bool clear=false);
    void __fastcall LoadKeys();
};
//---------------------------------------------------------------------------
extern TCpkKeyWin1 *CpkKeyWin1;
//---------------------------------------------------------------------------
#endif
